from paida.paida_core.PAbsorber import *
from paida.paida_core.IConstants import *
from paida.paida_core.PExceptions import *
from paida.paida_core.PUtilities import *
from paida.paida_core.ITree import *

import types
import os

_initialXml = """<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE aida SYSTEM "http://aida.freehep.org/schemas/3.2.1/aida.dtd">
<aida version="%s">
	<implementation package="PAIDA" version="%s"/>
</aida>""" % (IConstants.AIDA_VERSION, IConstants.PAIDA_VERSION)

class ITreeFactory:

	def create(self, data1 = None, data2 = None, data3 = None, data4 = None, data5 = None):
		storeTypes = ['xml']
		if (data1 == None) and (data2 == None) and (data3 == None) and (data4 == None) and (data5 == None):
			storeName = None
			storeType = 'xml'
			readOnly = True
			createNew = False
			option = optionAnalyzer(None)
		elif (type(data1) in types.StringTypes) and (data2 == None) and (data3 == None) and (data4 == None) and (data5 == None):
			storeName = data1
			storeType = 'xml'
			readOnly = False
			createNew = True
			option = optionAnalyzer(None)
		elif (type(data1) in types.StringTypes) and (type(data2) in types.StringTypes) and (data3 == None) and (data4 == None) and (data5 == None):
			storeName = data1
			storeType = data2.lower()
			readOnly = False
			createNew = True
			option = optionAnalyzer(None)
		elif (type(data1) in types.StringTypes) and (type(data2) in types.StringTypes) and (data3 in [True, False]) and (data4 == None) and (data5 == None):
			storeName = data1
			storeType = data2.lower()
			readOnly = data3
			createNew = True
			option = optionAnalyzer(None)
		elif (type(data1) in types.StringTypes) and (type(data2) in types.StringTypes) and (data3 in [True, False]) and (data4 in [True, False]) and (data5 == None):
			storeName = data1
			storeType = data2.lower()
			readOnly = data3
			createNew = data4
			option = optionAnalyzer(None)
		elif (type(data1) in types.StringTypes) and (type(data2) in types.StringTypes) and (data3 in [True, False]) and (data4 in [True, False]) and (type(data5) in types.StringTypes):
			storeName = data1
			storeType = data2.lower()
			readOnly = data3
			createNew = data4
			option = optionAnalyzer(data5)

		if storeName == '':
			return self.create()
		if storeType not in storeTypes:
			raise IllegalArgumentException('Store type "%s" is not in %s.' % (storeType, storeTypes))
		if readOnly:
			if storeName and (not os.path.exists(storeName)):
				raise IOException('%s does not exist.' % storeName)
		else:
			if not os.path.exists(storeName):
				if createNew:
					storeFile = file(storeName, 'w')
					storeFile.write(_initialXml)
					storeFile.close()
				else:
					raise IOException('%s does not exist.' % storeName)
		return ITree(storeName, storeType, readOnly, option)
